/*
Copyright (C) 2013  jul@siilia.fr

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

const Gtk = imports.gi.Gtk;
const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();
//const Meta = imports.gi.Meta;
const Convenience = Me.imports.convenience;
const _ = imports.gettext.domain("gnome-shell-extension-mouse-travel").gettext;


let settings;
let combo_pixelsize;
let button_reset;

function init() {
	settings = Convenience.getSettings();
	Convenience.initTranslations("gnome-shell-extension-mouse-travel");
}

function create_combo_pixelsize() {
	let hbox = new Gtk.Box({ orientation: Gtk.Orientation.HORIZONTAL });
	let label = new Gtk.Label({label: _("Monitor size and display resolution :"),xalign: 0 });
	let combo_pixelsize = new Gtk.ComboBoxText({});
	combo_pixelsize.append("0.2798","14.1\"-1024x768 : 0.2798mm");
	combo_pixelsize.append("0.2269","14\"-1366x768 : 0.2269mm");
	combo_pixelsize.append("0.2977","15\"-1024x768 : 0.2977mm");
	combo_pixelsize.append("0.2893","17\"-1280x768 : 0.2893mm");
	combo_pixelsize.append("0.2634","17\"-1280x1024 : 0.2634mm");
	combo_pixelsize.append("0.2543","17\"-1440x900 : 0.2543mm");
	combo_pixelsize.append("0.2789","18\"-1280x1024 : 0.2789mm");
	combo_pixelsize.append("0.2982","18.4\"-1366x768 : 0.2982mm");
	combo_pixelsize.append("0.2944","19\"-1280x1024 : 0.2944mm");
	combo_pixelsize.append("0.2842","19\"-1440x900 : 0.2842mm");
	combo_pixelsize.append("0.2436","19\"-1680x1050 : 0.2436mm");
	combo_pixelsize.append("0.2903","20\"-1400x1050 : 0.2903mm");
	combo_pixelsize.append("0.2767","20\"-1600x900 : 0.2767mm");
	combo_pixelsize.append("0.2564","20\"-1680x1050 : 0.2564mm");
	combo_pixelsize.append("0.2553","20.1\"-1600x1200 : 0.2553mm");
	combo_pixelsize.append("0.2692","21\"-1680x1050 : 0.2692mm");
	combo_pixelsize.append("0.2705","21.3\"-1600x1200 : 0.2705mm");
	combo_pixelsize.append("0.2479","21.5\"-1920x1080 : 0.2479mm");
	combo_pixelsize.append("0.2942","22\"-1600x1024 : 0.2942mm");
	combo_pixelsize.append("0.2821","22\"-1680x1050 : 0.2821mm");
	combo_pixelsize.append("0.2537","22\"-1920x1080 : 0.2537mm");
	combo_pixelsize.append("0.2490","22.2\"-1920x1200 : 0.2490mm");
	combo_pixelsize.append("0.1245","22.2\"-3840x2400 : 0.1245mm");
	combo_pixelsize.append("0.2652","23\"-1920x1080 : 0.2652mm");
	combo_pixelsize.append("0.258","23\"-1920x1200 : 0.258mm");
	combo_pixelsize.append("0.2766","24\"-1920x1080 : 0.2766mm");
	combo_pixelsize.append("0.2691","24\"-1920x1200 : 0.2691mm");
	combo_pixelsize.append("0.2917","26\"-1920x1200 : 0.2917mm");
	combo_pixelsize.append("0.3113","27\"-1920x1080 : 0.3113mm");
	combo_pixelsize.append("0.3029","27\"-1920x1200 : 0.3029mm");
	combo_pixelsize.append("0.2335","27\"-2560x1440 : 0.2335mm");
	combo_pixelsize.append("0.2524","30\"-2560x1600 : 0.2524mm");
	combo_pixelsize.append("0.635","32\"-1024x768 : 0.635mm");
	combo_pixelsize.append("0.7938","40\"-1024x768 : 0.7938mm");
	combo_pixelsize.set_active_id(settings.get_double("pixelsize")+"")
	combo_pixelsize.connect('changed', function() {
		settings.set_double("pixelsize", combo_pixelsize.get_active_id() );
		
	});
	hbox.pack_start(label, true, true, 0);
	hbox.add(combo_pixelsize);
	return hbox;
}

/*
function createtestArea() {
	let hbox = new Gtk.Box({ orientation: Gtk.Orientation.HORIZONTAL });
	let area = new St.DrawingArea();
	//area.set_width(200);
	//area.set_height(200);
	
	return hbox;
}
*/
function create_button_reset() {
	let hbox = new Gtk.Box({ orientation: Gtk.Orientation.HORIZONTAL });
	let label = new Gtk.Label({label: _("Reset travel :"),xalign: 0 });
	let button_reset = new Gtk.Button( { label: _("Reset") });
	button_reset.connect( "clicked", function() { settings.set_uint("length", 0); settings.set_uint("duration", 0); });
	hbox.pack_start(label, true, true, 0);
	hbox.add(button_reset);	
	return hbox;
}


function buildPrefsWidget() {
	let frame = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, border_width: 10 });
  let vbox = new Gtk.Box({ orientation: Gtk.Orientation.VERTICAL, margin: 20, margin_top: 10 });
	vbox.add( create_combo_pixelsize() );
	vbox.add( create_button_reset() );

	frame.add(vbox);
	frame.show_all();
	return frame;
}
